#ifndef OPALPAINT_H
#define OPALPAINT_H


#define OPVERSION	2
#define OPREVISION	2

#define OPBLACK		0L
#define OPGREY		1L
#define OPBLUE		2L
#define OPWHITE		3L


enum DrawModes
	{ Paint, Additive, Subtractive, Negative, Shade,
	  Posterise, Gamma, Brilliance, Contrast, Colour, Hue,
	  TintH, TintHS, Colourise, Sharpen, Smooth, Smear,
	  Mosaic, Spare1, Spare2, Spare3, Spare4, UndoPaint
	};

enum ToolTypes
	{ FreeHand,Continuous,Line,Rectangle,SolidRect,
	  Ellipse, SolidEllipse, Poly, SolidPoly, Curve,
	  FloodFill, SolidContinuous, ResizeBrush,
	  RotateBrush, DefineRange, GridAdjust,TextureAdjust,
	  DefBrushResize, PlaceHandle, ShearH, ShearV, BendH,
	  BendV, MagicWand
	};


	/* TagITems for Build_Req_Tags() */
#define OPBR_Dummy		(TAG_USER | 32)
#define OPBR_Width		(OPBR_Dummy + 1)
#define OPBR_Height		(OPBR_Dummy + 2)
#define OPBR_Flags		(OPBR_Dummy + 3)
#define OPBR_IText		(OPBR_Dummy + 4)
#define OPBR_Gadgets		(OPBR_Dummy + 5)
#define OPBR_GadFunc		(OPBR_Dummy + 6)
#define OPBR_InitFunc		(OPBR_Dummy + 7)
#define OPBR_MouseMoveFunc	(OPBR_Dummy + 8)
#define OPBR_HelpX		(OPBR_Dummy + 9)
#define OPBR_HelpY		(OPBR_Dummy + 10)
#define OPBR_AGuideName		(OPBR_Dummy + 11)
#define OPBR_Context		(OPBR_Dummy + 12)


/* Flags for Build_Request() */
#define BRF_CANCEL	0x1		/* Include Cancel gadget	*/
#define BRF_GADGETS 	0x8		/* Contains other misc gadgets	*/
#define BRF_RETURN  	0x10		/* Don't handle messages	*/
#define BRF_MBUTTONS	0x20		/* Signal on mouse presses	*/
#define BRF_NOOK	0x40		/* No ok gadget			*/
#define BRF_ALLOWRMB	0x80		/* Allow RMB presses on gadgets */
#define BRF_BIGGADS	0x100		/* Use larger OK & Cancel gads	*/
#define BRF_GADHELP	0x200		/* Gadget help text.		*/
#define BRF_MEDGADS	0x400
#define BRF_FORCETOP	0x800		/* Place Requester at line 0	*/
#define BRF_DRAGABLE	0x1000
#define BRF_AMIGAGUIDE	0x2000

#ifndef DRAWMODES_H
#include "opal/drawmodes.h"
#endif

#ifndef ARTISTTOOLS_H
#include "opal/atool.h"
#endif

#ifndef PAPER_H
#include "opal/paper.h"
#endif

#endif


