#ifndef DRAWMODES_H
#define DRAWMODES_H

#ifndef EXEC_TYPES_H
#include "exec/types.h"
#endif

#ifndef OPALLIB_H
#include "opal/opallib.h"
#endif


#define MAX_CONV_WINDOW	31

struct DModeInfo
	{ USHORT OPVersion;
	  USHORT OPRevision;
	  struct OpalScreen *DispScrn;
	  struct OpalScreen *FullImage;
	  struct OpalScreen *SecImage;
	  struct SetUp *SetUp;
	  struct OpalBase *OpalBase;
	  UBYTE PenRed,PenGreen,PenBlue;
	  UBYTE Pad;
	  SHORT RegionX,RegionY,RegionW,RegionH;
	  void (*Render_Func) (SHORT x, SHORT y, SHORT R, SHORT G, SHORT B);
	  void (*Display_ReadPixel) (SHORT x, SHORT y, UBYTE *R, UBYTE *G, UBYTE *B);
	  void (*Undo_ReadPixel) (SHORT x, SHORT y, UBYTE *R, UBYTE *G, UBYTE *B);
	  void (*Sec_ReadPixel) (SHORT x, SHORT y, UBYTE *R, UBYTE *G, UBYTE *B);
	  void (*RGB_to_HSV) (SHORT R,SHORT G,SHORT B,USHORT *H, USHORT *S,USHORT *V);
	  void (*RGB_to_V) (SHORT R,SHORT G,SHORT B,USHORT *V);
	  void (*RGB_to_SV) (SHORT R,SHORT G,SHORT B,USHORT *S,USHORT *V);
	  void (*HSV_to_RGB) (ULONG H,ULONG S,ULONG V,UBYTE *R,UBYTE *G,UBYTE *B);
	  BOOL (*Build_Request) (SHORT Width,SHORT Height,SHORT Flags,struct IntuiText *Text,
		struct Gadget *OtherGads,void (*GadgetFunc)(),
		void (*InitFunc)(),void (*MMFunc)(),SHORT HelpX,SHORT HelpY,
		STRPTR BaseName, STRPTR *Context);
	  void (*User_Message) (char *Mess);
	  BOOL (*Ask_User) (char *Mess);
	  BOOL (*File_Req) (char *Hail,char *Extension, char *Path, char *FileName);
	  void (*OPEndRequest)(void);
	  struct Screen *OpalScreen;
	  struct Window *OpalWindow;
	  void (*Refresh_Menu)(void);
	  void (*Zap_Image)(void);
	  void (*Do_Preview)(void);
	  void (*Stop_Preview)(void);
	  UBYTE (*Paper_Depth) (SHORT x, SHORT y);
	  BOOL (*Build_Req_Tags) (struct TagItem *tagList);
	};


struct DModeConfig
	{ char *ModeName;
	  BPTR Segment;
	  void (*DModeFunc)(SHORT x, SHORT y, SHORT R, SHORT G, SHORT B);
	  void (*CleanUp) (void);
	  void (*NewBrush) (SHORT x, SHORT y);
	  void (*NewStroke) (void);
	  void (*DMode_Options) (void);
	  struct DModeInfo *DModeInfo;
	  ULONG Flags;
	  UWORD  Percentage;
	  char *HelpText;
	  USHORT ModeVersion;	/* version of opalpaint mode was written for */
	  USHORT ModeRevision;
	};

	/* Flags */
#define DMF_NEEDPERCENT	0x1
#define DMF_SPLITRANGE	0x2
#define DMF_WINDOW	0x4
#define DMF_COLOURMAP	0x8
#define DMF_BOOTUP	0x10
#define DMF_BUILDUP	0x20	/* override Brush Build up prefs */

#endif


