#ifndef PAPER_H
#define PAPER_H

#ifndef EXEC_TYPES_H
#include "exec/types.h"
#endif

#ifndef	LIBRARIES_DOS_H
#include "libraries/dos.h"
#endif



struct PaperInfo
	{ USHORT OPVersion;
	  USHORT OPRevision;
	  BOOL (*Build_Request) (SHORT Width,SHORT Height,SHORT Flags,struct IntuiText *Text,
		struct Gadget *OtherGads,void (*GadgetFunc)(),
		void (*InitFunc)(),void (*MMFunc)(),SHORT HelpX,SHORT HelpY,
		STRPTR BaseName, STRPTR *Context);
	  void (*User_Message) (char *Mess);
	  BOOL (*Ask_User) (char *Mess);
	  BOOL (*File_Req) (char *Hail,char *Extension, char *Path, char *FileName);
	  void (*OPEndRequest)(void);
	  struct Screen *OpalScreen;
	  struct Window *OpalWindow;
	  void (*Refresh_Menu)(void);
	  BOOL (*Build_Req_Tags) (struct TagItem *tagList);
	};


struct PaperConfig
	{ ULONG Flags;		/* Not currently used		*/
	  UWORD Courseness;	/* Paper Courseness (or depth)	*/
	  char PaperName[30];
	  BPTR Segment;
	  SHORT PageWidth;
	  SHORT PageHeight;
	  SHORT Variant;
	  SHORT NumVariants;
	  char **VariantText;
	  UBYTE (*Paper_Func) (SHORT x, SHORT y);
	  void (*CleanUp) (void);
	  void (*Paper_Options) (void);
	  struct PaperInfo *PaperInfo;
	  USHORT PaperVersion;		/* version of opalpaint paper type */
	  USHORT PaperRevision;		/*  was written for. */
	};


#endif


